/*****************************************************************************************\
|                           This GetTVscript is written by kael                           |
|                                    modified by Hlger                                   |
| V.2   - expanded by Droideka                                                            |
| V.2.1 - modified by Rimion                                                              |
|         omtv.se made some minor changes on the site.                                    | 
| V.2.2 - modified by Rimion (080917)                                                     |
|         omtv.se har gjort om sin sida.                                                  | 
|         La till funktionerna GetTV(channel, ahead) och GetBar(channel). I Samurize      |
|         Config Editor kan du nu med hjlp av parametrar ange vilken kanal som ska       |
|         anvndas (ex. SVT1, TV8, TV3, SVT_HD) och vilket program som ska visas.         |
|         0 = det som snds nu, 1 = nsta program, 2 =...                                 |  
\*****************************************************************************************/
var showTime = true				;// Option to show the time in the output (true or false)
var timeDelimiter = ":"				;// Option what to separate hours and minutes with(":" "." or what you want)
var timeProgramSeparator = " "			;// Option what to separate time and program with
var noProgramYet = "Inget program"		;// The text showing when there are no program yet
var noProgramNow = "Sndningsuppehll"		;// The text showing when there are no program right now
var noProgramEnd = "Sndningsslut"		;// The text showing when there are no program any more

/*
To add your other channels just copy one of the sets of channels and change the function name to something unique and change the string-parameter to the apropriate name...
It has to be the right link name, you can check the link name by hovering over the channel icon at: http://www.omtv.se/kanaler/

example:
to add "Canal+ Sport" you would notice the end of the link to be "Canal+_Sport"
http://www.omtv.se/tabla/Canal+_Sport/
so the fuction would look like this:
function GetCanalPlusSport() { return GetTV_("Canal+_Sport", 0); }
*/

function GetTV(channel, ahead) {return GetTV_(channel, parseInt(ahead)); }
function GetBar(channel) {return GetBar_(channel); }

function GetSVT1() { return GetTV_("SVT1", 0); }
function GetBarSVT1() { return GetBar_("SVT1"); }
function GetNextSVT1() { return GetTV_("SVT1", 1); }

function GetSVT2() { return GetTV_("SVT2", 0); }
function GetBarSVT2() { return GetBar_("SVT2"); }
function GetNextSVT2() { return GetTV_("SVT2", 1); }

function GetTV3() { return GetTV_("TV3", 0); }
function GetBarTV3() { return GetBar_("TV3"); }
function GetNextTV3() { return GetTV_("TV3", 1); }

function GetTV4() { return GetTV_("TV4", 0); }
function GetBarTV4() { return GetBar_("TV4"); }
function GetNextTV4() { return GetTV_("TV4", 1); }

function GetTV4_Plus() { return GetTV_("TV4_Plus", 0); }
function GetBarTV4_Plus() { return GetBar_("TV4_Plus"); }
function GetNextTV4_Plus() { return GetTV_("TV4_Plus", 1); }

function GetTV4_Fakta() { return GetTV_("TV4_Fakta", 0); }
function GetBarTV4_Fakta() { return GetBar_("TV4_Fakta"); }
function GetNextTV4_Fakta() { return GetTV_("TV4_Fakta", 1); }

function GetTV4_Film() { return GetTV_("TV4_Film", 0); }
function GetBarTV4_Film() { return GetBar_("TV4_Film"); }
function GetNextTV4_Film() { return GetTV_("TV4_Film", 1); }

function GetTV4_Guld() { return GetTV_("TV4_Guld", 0); }
function GetBarTV4_Guld() { return GetBar_("TV4_Guld"); }
function GetNextTV4_Guld() { return GetTV_("TV4_Guld", 1); }

function GetTV4_Komedi() { return GetTV_("TV4_Komedi", 0); }
function GetBarTV4_Komedi() { return GetBar_("TV4_Komedi"); }
function GetNextTV4_Komedi() { return GetTV_("TV4_Komedi", 1); }

function GetTV400() { return GetTV_("TV400", 0); }
function GetBarTV400() { return GetBar_("TV400"); }
function GetNextTV400() { return GetTV_("TV400", 1); }

function GetKanal5() { return GetTV_("Kanal_5", 0); }
function GetBarKanal5() { return GetBar_("Kanal_5"); }
function GetNextKanal5() { return GetTV_("Kanal_5", 1); }

function Get6an() { return GetTV_("TV6", 0); }
function GetBar6an() { return GetBar_("TV6"); }
function GetNext6an() { return GetTV_("TV6", 1); }

function GetTV_1000() { return GetTV_("TV_1000", 0); }
function GetBarTV_1000() { return GetBar_("TV_1000"); }
function GetNextTV_1000() { return GetTV_("TV_1000", 1); }

function GetTV_1000_Action() { return GetTV_("TV_1000_Action", 0); }
function GetBarTV_1000_Action() { return GetBar_("TV_1000_Action"); }
function GetNextTV_1000_Action() { return GetTV_("TV_1000_Action", 1); }

function GetTV_1000_Classic() { return GetTV_("TV_1000_Classic", 0); }
function GetBarTV_1000_Classic() { return GetBar_("TV_1000_Classic"); }
function GetNextTV_1000_Classic() { return GetTV_("TV_1000_Classic", 1); }

function GetTV_1000_Family() { return GetTV_("TV_1000_Family", 0); }
function GetBarTV_1000_Family() { return GetBar_("TV_1000_Family"); }
function GetNextTV_1000_Family() { return GetTV_("TV_1000_Family", 1); }

function GetTV_1000_Nordic() { return GetTV_("TV_1000_Nordic", 0); }
function GetBarTV_1000_Nordic() { return GetBar_("TV_1000_Nordic"); }
function GetNextTV_1000_Nordic() { return GetTV_("TV_1000_Nordic", 1); }

function GetTV_1000_plus1() { return GetTV_("TV1000_+1", 0); }
function GetBarTV_1000_plus1() { return GetBar_("TV1000_+1"); }
function GetNextTV_1000_plus1() { return GetTV_("TV1000_+1", 1); }

function GetDisney_Channel() { return GetTV_("Disney_Channel", 0); }
function GetBarDisney_Channel() { return GetBar_("Disney_Channel"); }
function GetNextDisney_Channel() { return GetTV_("Disney_Channel", 1); }

function GetTV_(channel, count)
{
	var txt = GetPage_(channel);
	
	if(txt.substr(0,5)=="Error") return txt;
	
	try
	{
		var now = -1;
		var offset = -2;
		var lines = txt.split("\r\n");
		
		// Check if the last program = noProgramEnd
		// omtv.se sometimes repeats the next day first program as the current day last progam
		// we then have to set the offset to -3 to skip the last program in the saved file
		if (lines[lines.length-2].indexOf(noProgramEnd) < 0) offset = -3;
		
		for(var i=lines.length+offset;i>=0;i--)
		{
			var time = lines[i].substring(0,5);
			
			_time = new Date();

			if((parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2)))<6) _time.setHours(parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2))+18,parseInt(time.substring(3,4))*10 + parseInt(time.substring(4,5)),0,0);
			else _time.setHours(parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2))-6,parseInt(time.substring(3,4))*10 + parseInt(time.substring(4,5)),0,0);
			
			_now = new Date();
			if(_now.getHours()<6) _now.setHours(_now.getHours()+18);
			else _now.setHours(_now.getHours()-6);

			if(_time<_now)
			{
				now = i;
				break;
			}
		}

		if((now+count>=0) && (now+count<=lines.length-2))
			return lines[now+count];
		else
			return noProgramYet;
	}
	catch(e)
	{
		return "Error parsing file";
	}
}

function GetBar_(channel)
{
	var txt = GetPage_(channel);
	if(txt.substr(0,5)=="Error") return txt;

	try
	{

		var now = -1;
		var lines = txt.split("\r\n");
		var offset = -2;
		
		// Check if the last program = noProgramEnd
		// omtv.se somtimes repeats the next day first program as the current day last progam
		// we then have to set the offset to -3 to skip the last program in the saved file
		if (lines[lines.length-2].indexOf(noProgramEnd) < 0) offset = -3;
		
		for(var i=lines.length+offset;i>=0;i--)
		{
			var time = lines[i].substring(0,5);
			_time = new Date();

			if((parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2)))<6) _time.setHours(parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2))+18,parseInt(time.substring(3,4))*10 + parseInt(time.substring(4,5)),0,0);
			else _time.setHours(parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2))-6,parseInt(time.substring(3,4))*10 + parseInt(time.substring(4,5)),0,0);

			_now = new Date();
			if(_now.getHours()<6) _now.setHours(_now.getHours()+18);
			else _now.setHours(_now.getHours()-6);

			if(_time<_now)
			{
				now = i;
				break;
			}
		}

		if(now<0 || now>=(lines.length-2))
			return 0;

		var time1 = lines[now].substring(0,5);
		var time1h = time1.substring(0,2);
		var time1m = time1.substring(3,5);
		var time2 = lines[now+1].substring(0,5);
		var time2h = time2.substring(0,2);
		var time2m = time2.substring(3,5);
		if(time1h<6) time1h=time1h*1+18; else time1h-=6;
		if(time2h<6) time2h=time2h*1+18; else time2h-=6;

		
		var totalmins = (time2h-time1h)*60+(time2m-time1m);
		var runningminutes = (_now.getHours()-time1h)*60+(_now.getMinutes()-time1m);
		return runningminutes/totalmins*100;
	}
	catch(e)
	{
		return "Error parsing file";
	}
}

function GetPage_(channel)
{
	try
	{
		var fs = new ActiveXObject("Scripting.FileSystemObject");
		try{var ADODBS=new ActiveXObject("ADODB.Stream");}catch(er){var ADODBS=false;}
		
		try
		{
			var file=fs.GetSpecialFolder(2)+"\\"+channel+".tv";
			
			if(fs.FileExists(file))
			{
				var f=fs.GetFile(file);
				var filetime = new Date(f.DateLastModified);
				var now = new Date();
				var timeToDownload = new Date();
				timeToDownload.setHours(6,15,0);
				if(timeToDownload>now || filetime>timeToDownload)
				{
						var filen = f.OpenAsTextStream(1);
						var txt = filen.ReadAll();
						filen.Close();
						return txt;
				}
			}
		}
		catch(e)
		{
			return "Error reading from file";
		}
		finally
		{
			delete filetime;
			delete now;
			delete timeToDownload;
		}
	
		try
		{
			var adress = "http://www.omtv.se/tabla/"+channel+"/";
			
			var http = new ActiveXObject("Microsoft.XMLHTTP");
			http.Open("GET",adress ,false);
			http.send();
			var html = "Error";
			if (http.Status==200)
			{
				if(ADODBS){
					try{
						ADODBS.Open();
						ADODBS.Type=1;    // Binary
						ADODBS.Write(http.responseBody);  // Write the response as a byte stream.
						ADODBS.Position=0;   // Move back to the start of the stream to be able to change type and charset.
						ADODBS.Type=2;  // Text
						ADODBS.Charset="ISO-8859-1"; // Default to Latin 1 Western, West European.
						html=ADODBS.ReadText();
						ADODBS.Close();
					}
					catch(er){
						html=http.responseText;  // Something failed, default back to responseText, UTF-8 is forced.
					}
				}
			}
			html = fixHTMLcodes_(html);
		}
		catch(e)
		{
			return "Error downloading page";
		}
		finally
		{
			delete http;
		}
	
		try
		{
			html = between(html, "<tbody>", "</tbody>");
			
			var txt="";
			var lines = html.split("</tr>");
			var endtime="";

			// Had to change to 'lines.length-1' for some reason
			for(var i=0;i<lines.length-1;i++)
			{
				var time = lines[i].substr(lines[i].indexOf("</td>")-5,5);
				var program = between(lines[i], "<h5>", "</h5>");
				var desc = between(lines[i], "<p>", "<");
				
	      			if(program.indexOf("\r\n")!=-1)
					program = program.substr(0,program.indexOf("\r\n"));
				
				if(endtime!="")
				{
					var _endtime = new Date();
					_endtime.setHours(parseInt(endtime.substring(0,1))*10 + parseInt(endtime.substring(1,2)),parseInt(endtime.substring(3,4))*10 + parseInt(endtime.substring(4,5)),0,0);
					var _time = new Date();
					_time.setHours(parseInt(time.substring(0,1))*10 + parseInt(time.substring(1,2)),parseInt(time.substring(3,4))*10 + parseInt(time.substring(4,5)),0,0);
					if(_endtime<_time)
					{
						if(showTime)
							txt+=endtime.substring(0,2)+timeDelimiter+endtime.substring(3,5)+timeProgramSeparator;
						txt+=noProgramNow+"\r\n";
					}
				}
				
				endtime = lines[i].substr(lines[i].indexOf("(")+9,5);
				
				if(endtime.substr(2,1)!=".")
					endtime = "";
				
				if(showTime)
					txt+=time.substring(0,2)+timeDelimiter+time.substring(3,5)+timeProgramSeparator;
				//added
				txt+=program+"%tt"+desc+"\r\n";
				//added
			}
			
			if(endtime!="")
			{
				
				var _endtime = new Date();
				
				_endtime.setHours(parseInt(endtime.substring(0,1))*10 + parseInt(endtime.substring(1,2)),parseInt(endtime.substring(3,4))*10 + parseInt(endtime.substring(4,5)),0,0);
				var _time = new Date();
				_time.setHours(5,59,0);
				if(_endtime<_time)
				{
					if(showTime)
						txt+=endtime.substring(0,2)+timeDelimiter+endtime.substring(3,5)+timeProgramSeparator;
					txt+=noProgramEnd+"\r\n";
				}
			}
		}
		catch(e)
		{
			return "Error parsing page";
		}
		
		try
		{
			var file=fs.CreateTextFile(file,true);
			file.Write(txt);
		}	
		catch(e)
		{
			return "Error writing to file";
		}
		finally
		{
			file.Close();
		}
	}
	catch(e)
	{
		return "Error creating FileSystemObject";
	}
	finally
	{
		delete fs;
	}
	return txt;

}

function between(str, start, stop)
{
	str = str.substr(str.indexOf(start)+start.length);
	str = str.substr(0,str.indexOf(stop));
	return str;
}

function fixHTMLcodes_(str)
{
	str = str.replace(/&aring;/g, "");
	str = str.replace(/&auml;/g, "");
	str = str.replace(/&ouml;/g, "");
	str = str.replace(/&Aring;/g, "");
	str = str.replace(/&Auml;/g, "");
	str = str.replace(/&Ouml;/g, "");
	str = str.replace(/&amp;/g, "&");
	str = str.replace(/&quot;/g, "\"");
	str = str.replace(/&#130;/g, ",");
	str = str.replace(/&#131;/g, "f");
//	str = str.replace(/&#132;/g, """);
	str = str.replace(/&#133;/g, ".");
	str = str.replace(/&#134;/g, "?");
	str = str.replace(/&#135;/g, "?");
	str = str.replace(/&#136;/g, "^");
	str = str.replace(/&#137;/g, "?");
	str = str.replace(/&#138;/g, "S");
	str = str.replace(/&#139;/g, "<");
	str = str.replace(/&#140;/g, "O");
	str = str.replace(/&#145;/g, "'");
	str = str.replace(/&#146;/g, "'");
//	str = str.replace(/&#147;/g, """);
//	str = str.replace(/&#148;/g, """);
	str = str.replace(/&#149;/g, ".");
	str = str.replace(/&#150;/g, "-");
	str = str.replace(/&#151;/g, "-");
	str = str.replace(/&#152;/g, "~");
	str = str.replace(/&#153;/g, "T");
	str = str.replace(/&#154;/g, "s");
	str = str.replace(/&#155;/g, ">");
	str = str.replace(/&#156;/g, "o");
	str = str.replace(/&#159;/g, "Y");
	str = str.replace(/&#160;/g, " ");
	str = str.replace(/&#161;/g, "");
	str = str.replace(/&#162;/g, "");
	str = str.replace(/&#163;/g, "");
	str = str.replace(/&#164;/g, "");
	str = str.replace(/&#165;/g, "");
	str = str.replace(/&#166;/g, "");
	str = str.replace(/&#167;/g, "");
	str = str.replace(/&#168;/g, "");
	str = str.replace(/&#169;/g, "");
	str = str.replace(/&#170;/g, "");
	str = str.replace(/&#171;/g, "");
	str = str.replace(/&#172;/g, "");
	str = str.replace(/&#173;/g, "");
	str = str.replace(/&#174;/g, "");
	str = str.replace(/&#175;/g, "");
	str = str.replace(/&#176;/g, "");
	str = str.replace(/&#177;/g, "");
	str = str.replace(/&#178;/g, "");
	str = str.replace(/&#179;/g, "");
	str = str.replace(/&#180;/g, "");
	str = str.replace(/&#181;/g, "");
	str = str.replace(/&#182;/g, "");
	str = str.replace(/&#183;/g, "");
	str = str.replace(/&#184;/g, "");
	str = str.replace(/&#185;/g, "");
	str = str.replace(/&#186;/g, "");
	str = str.replace(/&#187;/g, "");
	str = str.replace(/&#188;/g, "");
	str = str.replace(/&#189;/g, "");
	str = str.replace(/&#190;/g, "");
	str = str.replace(/&#191;/g, "");
	str = str.replace(/&#192;/g, "");
	str = str.replace(/&#193;/g, "");
	str = str.replace(/&#194;/g, "");
	str = str.replace(/&#195;/g, "");
	str = str.replace(/&#196;/g, "");
	str = str.replace(/&#197;/g, "");
	str = str.replace(/&#198;/g, "");
	str = str.replace(/&#199;/g, "");
	str = str.replace(/&#200;/g, "");
	str = str.replace(/&#201;/g, "");
	str = str.replace(/&#202;/g, "");
	str = str.replace(/&#203;/g, "");
	str = str.replace(/&#204;/g, "");
	str = str.replace(/&#205;/g, "");
	str = str.replace(/&#206;/g, "");
	str = str.replace(/&#207;/g, "");
	str = str.replace(/&#208;/g, "");
	str = str.replace(/&#209;/g, "");
	str = str.replace(/&#210;/g, "");
	str = str.replace(/&#211;/g, "");
	str = str.replace(/&#212;/g, "");
	str = str.replace(/&#213;/g, "");
	str = str.replace(/&#214;/g, "");
	str = str.replace(/&#215;/g, "");
	str = str.replace(/&#216;/g, "");
	str = str.replace(/&#217;/g, "");
	str = str.replace(/&#218;/g, "");
	str = str.replace(/&#219;/g, "");
	str = str.replace(/&#220;/g, "");
	str = str.replace(/&#221;/g, "");
	str = str.replace(/&#222;/g, "");
	str = str.replace(/&#223;/g, "");
	str = str.replace(/&#224;/g, "");
	str = str.replace(/&#225;/g, "");
	str = str.replace(/&#226;/g, "");
	str = str.replace(/&#227;/g, "");
	str = str.replace(/&#228;/g, "");
	str = str.replace(/&#229;/g, "");
	str = str.replace(/&#230;/g, "");
	str = str.replace(/&#231;/g, "");
	str = str.replace(/&#232;/g, "");
	str = str.replace(/&#233;/g, "");
	str = str.replace(/&#234;/g, "");
	str = str.replace(/&#235;/g, "");
	str = str.replace(/&#236;/g, "");
	str = str.replace(/&#237;/g, "");
	str = str.replace(/&#238;/g, "");
	str = str.replace(/&#239;/g, "");
	str = str.replace(/&#240;/g, "");
	str = str.replace(/&#241;/g, "");
	str = str.replace(/&#242;/g, "");
	str = str.replace(/&#243;/g, "");
	str = str.replace(/&#244;/g, "");
	str = str.replace(/&#245;/g, "");
	str = str.replace(/&#246;/g, "");
	str = str.replace(/&#247;/g, "");
	str = str.replace(/&#248;/g, "");
	str = str.replace(/&#249;/g, "");
	str = str.replace(/&#250;/g, "");
	str = str.replace(/&#251;/g, "");
	str = str.replace(/&#252;/g, "");
	str = str.replace(/&#253;/g, "");
	str = str.replace(/&#254;/g, "");
	str = str.replace(/&#255;/g, "");

	return str;
}
